//
//  LAArrayAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/01/08.
//  Copyright 2011 LyricApps. All rights reserved.
//

@interface NSArray (LAArrayAdditions)

- (NSArray *)transformUsingBlock:(id (^)(id object))block;
- (BOOL)isEqualToArray:(NSArray *)array compareBlock:(BOOL (^)(id, id))compareBlock;
- (id)objectsValueForKeyPath:(NSString *)keyPath;
- (NSString *)uniqueValue:(NSString *)value withFormat:(NSString *)format pattern:(NSString *)pattern;
- (NSString *)CSVLineWithSeparator:(NSString *)separator;
- (NSArray *)flatArrayWithChildrenKeyPath:(NSString *)childrenKeyPath leafKeyPath:(NSString *)leafKeyPath;
- (NSArray *)flatArrayWithChildrenKeyPath:(NSString *)childrenKeyPath leafKeyPath:(NSString *)leafKeyPath includingGroups:(BOOL)includingGroups;
- (NSDictionary *)objectPathsMapWithKeyPath:(NSString *)keyPath childrenKeyPath:(NSString *)childrenKeyPath leafKeyPath:(NSString *)leafKeyPath;
- (NSArray *)groupsForKeyPath:(NSString *)keyPath;
#if !TARGET_OS_IPHONE
- (NSMenu *)groupsMenu;
#endif

@end
