//
//  LABadgeView.h
//  LAAdditions
//
//  Created by Cyril Anger on 20/12/2013.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <LAAdditions/LAFontAdditions.h>
#import <LAAdditions/LAViewAdditions.h>

@interface LABadgeView : LAControl

@property (strong, nonatomic) NSString *text;
@property (nonatomic) NSInteger value;
@property (strong, nonatomic) NSString *label;
@property (strong, nonatomic) LAFont *font;
@property (strong, nonatomic) LAColor *textColor;
@property (strong, nonatomic) LAColor *badgeColor;
@property (strong, nonatomic) LAColor *outlineColor;
@property (nonatomic) CGFloat outlineWidth;
@property (strong, nonatomic) LAColor *backgroundSelectionColor;

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *collapsingConstraint;

- (void)anchorToCorner:(LARectCorner)corner withOffset:(CGSize)offset;

@end

@interface LAView (LABadgeViewAdditions)

@property (nonatomic, readonly) LABadgeView *badge;

@end
