//
//  LADuration.h
//  LAAdditions
//
//  Created by Cyril Anger on 01/07/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface LADuration : NSDateComponents <NSCoding, NSCopying>

@property (readonly) NSCalendarUnit unit;
@property (readonly) NSInteger numberOfUnits;
@property (nonatomic) NSInteger days;
@property (nonatomic) NSInteger weeks;
@property (nonatomic) NSInteger months;
@property (nonatomic) NSInteger years;

+ (LADuration *)durationWithDays:(NSInteger)days;
+ (LADuration *)durationWithWeeks:(NSInteger)weeks;
+ (LADuration *)durationWithMonths:(NSInteger)months;
+ (LADuration *)durationWithYears:(NSInteger)years;

- (BOOL)isValid;
- (NSDate *)addToDate:(NSDate *)date count:(NSInteger)count;
- (NSInteger)numberOfPeriodsBetweenDate:(NSDate *)startDate andDate:(NSDate *)endDate includingRemainingDays:(BOOL)includingRemainingDays;
- (NSComparisonResult)compare:(LADuration *)duration;

@end
