//
//  LARule.h
//  iCompta
//
//  Created by Cyril Anger on 28/03/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LACondition.h>
#import <LAAdditions/LAImageAdditions.h>

@class LARulesGroup, LAAction;

@interface LAAbstractRule : LAManagedObject

@property (strong, nonatomic) LAManagedObject *library;
@property (strong, nonatomic) LARulesGroup *parent;
@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (strong, nonatomic) NSString *name;
@property (readonly) NSString *fullName;
@property (readonly) LAImage *icon;

@end

@interface LARule : LAAbstractRule

@property (strong, nonatomic) LACompoundCondition *condition;
@property (strong, nonatomic) NSOrderedSet *actions;

@end

@interface LARule (CoreDataGeneratedAccessors)

- (void)insertObject:(LAAction *)value inActionsAtIndex:(NSUInteger)index;
- (void)removeObjectFromActionsAtIndex:(NSUInteger)index;
- (void)insertActions:(NSArray *)values atIndexes:(NSIndexSet *)indexes;
- (void)removeActionsAtIndexes:(NSIndexSet *)indexes;
- (void)replaceObjectInActionsAtIndex:(NSUInteger)index withObject:(LAAction *)value;
- (void)replaceActionsAtIndexes:(NSIndexSet *)indexes withActions:(NSArray *)values;
- (void)addActionsObject:(LAAction *)value;
- (void)removeActionsObject:(LAAction *)value;
- (void)addActions:(NSOrderedSet *)values;
- (void)removeActions:(NSOrderedSet *)values;

@end

@interface LARulesGroup : LAAbstractRule

@property (strong, nonatomic) NSOrderedSet *rules;

- (void)sortRulesAlphabetically;

@end

@interface LARulesGroup (CoreDataGeneratedAccessors)

- (void)insertObject:(LAAbstractRule *)value inRulesAtIndex:(NSUInteger)index;
- (void)removeObjectFromRulesAtIndex:(NSUInteger)index;
- (void)insertRules:(NSArray *)values atIndexes:(NSIndexSet *)indexes;
- (void)removeRulesAtIndexes:(NSIndexSet *)indexes;
- (void)replaceObjectInRulesAtIndex:(NSUInteger)index withObject:(LAAbstractRule *)value;
- (void)replaceRulesAtIndexes:(NSIndexSet *)indexes withRules:(NSArray *)values;
- (void)addRulesObject:(LAAbstractRule *)value;
- (void)removeRulesObject:(LAAbstractRule *)value;
- (void)addRules:(NSOrderedSet *)values;
- (void)removeRules:(NSOrderedSet *)values;

@end

@interface LAAction : LAManagedObject <LATemplateControlledObject>

@property (strong, nonatomic) LARule *rule;
@property (strong, nonatomic) NSString *name;
@property (strong, nonatomic) LAParameter *parameter1;
@property (strong, nonatomic) LAParameter *parameter2;
@property (strong, nonatomic) LAParameter *parameter3;
@property (strong, nonatomic) LAParameter *parameter4;
@property (strong, nonatomic) LAParameter *parameter5;

@end
