//
//  LATreeNode.h
//  LAAdditions
//
//  Created by Cyril Anger on 24/03/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LATableCellView.h>

@class LATreeNodesDataSource;
@class LATreeController;

@interface LATreeNode : NSObject

@property (weak, nonatomic) LATreeController *controller;
@property (weak, nonatomic) LATreeNodesDataSource *parentDataSource;
@property (weak, nonatomic) LATreeNode *parentNode;
@property (nonatomic, readonly) NSArray *allParentNodes;
@property (weak, nonatomic) LATreeNode *previousNode;
@property (weak, nonatomic) LATreeNode *nextNode;
@property (strong, nonatomic, readonly) NSMutableArray *dataSources;
@property (nonatomic, readonly) NSArray *allDataSources;
@property (strong, nonatomic, readonly) NSMutableArray *nodes;
@property (nonatomic, readonly) NSArray *allNodes;
@property (nonatomic, readonly) NSArray *visibleDescendantNodes;
@property (strong, nonatomic, readonly) id representedObject;
@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (getter = isGroup, nonatomic) BOOL group;
@property (getter = isExpanded, nonatomic) BOOL expanded;
@property (getter = isSelected, nonatomic) BOOL selected;
@property (strong, nonatomic, readonly) NSString *ID;
@property (nonatomic, readonly) NSString *fullID;
@property (strong, nonatomic) LATableCellView *view;
@property (strong, nonatomic) NSString *viewIdentifier;

- (id)initLeaf:(BOOL)leaf withRepresentedObject:(id)representedObject ID:(NSString *)ID view:(LATableCellView *)view;
- (id)initLeaf:(BOOL)leaf withRepresentedObject:(id)representedObject ID:(NSString *)ID viewIdentifier:(NSString *)viewIdentifier;
- (LATreeNodesDataSource *)dataSourceNamed:(NSString *)name;
- (void)insertDataSource:(LATreeNodesDataSource *)dataSource atIndex:(NSUInteger)index;
- (void)addDataSource:(LATreeNodesDataSource *)dataSource;
- (void)removeDataSourceNamed:(NSString *)name;
- (NSIndexSet *)convertIndexes:(NSIndexSet *)indexes fromDataSource:(LATreeNodesDataSource *)dataSource;
- (void)insertNodes:(NSArray *)nodes atIndexes:(NSIndexSet *)indexes;
- (void)removeNodesAtIndexes:(NSIndexSet *)indexes;
- (NSUInteger)numberOfNodes;
- (LATreeNode *)nodeAtIndex:(NSUInteger)index;
- (LATreeNodesDataSource *)dataSourceWithID:(NSString *)ID;
- (LATreeNode *)nodeWithID:(NSString *)ID;

@end
