//
//  LAViewAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/06/08.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAImageAdditions.h>

#if TARGET_OS_IPHONE
#define LAView UIView
#define LAControl UIControl
#define LAViewAutoresizing UIViewAutoresizing
#define LAViewAutoresizingNone UIViewAutoresizingNone
#define LAViewAutoresizingFlexibleLeftMargin UIViewAutoresizingFlexibleLeftMargin
#define LAViewAutoresizingFlexibleWidth UIViewAutoresizingFlexibleWidth
#define LAViewAutoresizingFlexibleRightMargin UIViewAutoresizingFlexibleRightMargin
#define LAViewAutoresizingFlexibleTopMargin UIViewAutoresizingFlexibleTopMargin
#define LAViewAutoresizingFlexibleHeight UIViewAutoresizingFlexibleHeight
#define LAViewAutoresizingFlexibleBottomMargin UIViewAutoresizingFlexibleBottomMargin
#define LALayoutPriority UILayoutPriority
#define LAViewNoIntrinsicMetric UIViewNoIntrinsicMetric
#else
#define LAView NSView
#define LAControl NSControl
#define LAViewAutoresizing NSUInteger
#define LAViewAutoresizingNone NSViewNotSizable
#define LAViewAutoresizingFlexibleLeftMargin NSViewMinXMargin
#define LAViewAutoresizingFlexibleWidth NSViewWidthSizable
#define LAViewAutoresizingFlexibleRightMargin NSViewMaxXMargin
#define LAViewAutoresizingFlexibleTopMargin NSViewMinYMargin
#define LAViewAutoresizingFlexibleHeight NSViewHeightSizable
#define LAViewAutoresizingFlexibleBottomMargin NSViewMaxYMargin
#define LALayoutPriority NSLayoutPriority
#define LAViewNoIntrinsicMetric NSViewNoInstrinsicMetric
#endif

typedef void (^LAAnimationsBlock)(void);

typedef enum {
	LADirectionNone,
	LADirectionLeftToRight,
	LADirectionRightToLeft,
	LADirectionTopToBottom,
	LADirectionBottomToTop
} LADirection;

@interface LAView (LAViewAdditions)

#if TARGET_OS_IPHONE
- (void)updateSubviewsWithFontSizeBlock:(CGFloat (^)(LAView *view))fontSizeBlock;
- (void)adjustCenter:(LAPoint)center;
- (BOOL)isHiddenOrHasHiddenAncestor;
#else
- (void)bringSubviewToFront:(LAView *)view;
- (void)sendSubviewToBack:(LAView *)view;
- (void)setNeedsDisplay;
- (void)setNeedsLayout;
- (void)setNeedsUpdateConstraints;
#endif
- (void)resetAnchorPoint;
- (void)shakeWithDelegate:(id)delegate;
- (void)startWobbling;
- (void)stopWobbling;
- (void)makeTransitionToView:(LAView *)newView withDirection:(LADirection)direction completionHandler:(void (^)(void))completionHandler;
- (LAImage *)imageWithSize:(LASize)size;

#if !TARGET_OS_IPHONE
- (IBAction)openMenu:(id)sender;
#endif

@end

#if !TARGET_OS_IPHONE
@interface NSButton (LAViewAdditions)

- (IBAction)openMenu:(id)sender;

@end
#endif
